<?php
/*
Plugin Name: Tallyopia WordPress Plugin
Plugin URI: http://tallyopia.com
Description: Tallyopia provides analytics that you can view in your admin dashboard and even embed into your site using shortcodes.
Version: 1.3
Author URI: http://tallyopia.com
*/

#================================================
#	SETUP THE PLUGIN
#------------------------------------------------
if( !class_exists( 'WP_Http' ) ) {include_once( ABSPATH . WPINC. '/class-http.php' );}

TallyWordPressPlugin::$SERVER = 'http://' .TallyWordPressPlugin::GetTallyClientURL() . '.tallyopia.net';
TallyWordPressPlugin::$ANALYTICS_SERVER = 'http://' .TallyWordPressPlugin::GetTallyClientURL() . '.analytics.tallyopia.net';
TallyWordPressPlugin::InitJQuery();
TallyWordPressPlugin::HookActionToFooter();
TallyWordPressPlugin::AddShortcode();
TallyWordPressPlugin::AddDashboardMenu();
TallyWordPressPlugin::EnableShortcodesInWidgets();
TallyWordPressPlugin::AddGoalTrackingBoxes();
TallyWordPressPlugin::AddAdminBarMenu();
#================================================

class Hash {
	public static $Data = array();
	public static function init() {
		Hash::$Data['cid'] = null;
	}
}
Hash::init();

function TallyInDash() {

	$currentUser 	= wp_get_current_user();
	$tallyopiaCID 	= get_the_author_meta('tallyopia_customer_id',$currentUser->ID);

	//	Nothing below here for non admins
	if (!current_user_can('administrator')){return;}

	//	---------------------------------------------------------------
	//	BEGIN ADMIN MENU SETUP
	$tallyopiaIconURL =  TallyWordPressPlugin::GetTallyopiaIconURL();

	add_menu_page('Tallyopia Dash','Tallyopia Dash','administrator','tally-root',null,$tallyopiaIconURL,'4+1.0e-08');
	add_submenu_page('tally-root', 'Overview', 'Overview', 'administrator', 'tally-root', 'TallyDashOverview');
	add_submenu_page('tally-root', 'Live', 'Live Monitor', 'administrator', 'tally-live', 'TallyDashLive');
	add_submenu_page('tally-root', 'Last 24 Hours', 'Last 24 Hrs.', 'administrator', 'tally-24', 'TallyDashLast24');
	add_submenu_page('tally-root', 'Last 60 Days', 'Last 60 Days', 'administrator', 'tally-60', 'TallyDashLast90');
	add_submenu_page('tally-root', 'Analyze Readers', 'Analyze Readers', 'administrator', 'tally-readers-search', 'TallyDashSearchReaders');
	add_submenu_page('tally-root', 'Analyze Content', 'Analyze Content', 'administrator', 'tally-pages-search', 'TallyDashSearchPages');
	add_submenu_page('tally-root', 'Goal Tracking', 'Goal Tracking', 'administrator','tally-goals','TallyDashGoals');

	//	Only show these menus for the top level admins
	if (TallyWordPressPlugin::IsTopLevelAdmin()) {
		add_submenu_page('tally-root', 'Diagnostics', 'Diagnostics', 'administrator', 'tally-diagnostics', 'TallyDashDiagnostics');
		add_submenu_page('tally-root', 'Setup', 'Setup', 'administrator', 'tally-setup', 'TallyDashSetup');
	}
	//	END ADMIN MENU SETUP
	//	---------------------------------------------------------------

	//	---------------------------------------------------------------
	//	BEGIN NOC MENU SETUP
	/*
	 * 	NOC menus only require that a cid exists
	 *	To enter a cid, you must have admin access to the Setup menu, and that's only for admins.
	 *	So below, we use loose permissions, knowing that to get the CID you had to have better permissions.
	 *	This allows us more flexability in displaying the NOC menu on Tallyopia.com.
	*/
	if ($tallyopiaCID && strlen($tallyopiaCID)>5) {
		Hash::$Data['cid'] = $tallyopiaCID;
		add_menu_page('Tallyopia NOC','Tallyopia NOC','read','tally-root-noc',null,$tallyopiaIconURL,'4+2.0e-08');
		add_submenu_page('tally-root-noc', 'Live', 'Multisite Monitor', 'read', 'tally-root-noc', 'TallyDashLive');
		add_submenu_page('tally-root-noc','Site Uptime','Site Uptime','read','tally-uptime-noc','TallyUptime');
		add_submenu_page('tally-root-noc','Site Summary','Site Summary','read','tally-sitesummary-noc','TallySiteSummary');
	}
	//	END NOC MENU SETUP
	//	---------------------------------------------------------------



}


function TallyDashUtility($atts,$dataPath,$options=array()) {

	if (!array_key_exists('echo',$options)) {$options['echo'] = true;}
	if (!array_key_exists('postData',$options)) {$options['postData'] = array();}
	if (!array_key_exists('getData',$options)) {$options['getData'] = array();}

	$cid = Hash::$Data['cid'];

	//	Set isnoc based on the page name.
	$isnoc = 0;
	$page = $_GET['page'];
	$pageParts = explode('-',$page);
	if ('noc' == end($pageParts)) {$isnoc = 1;}

	$data = array();
	$data['site'] 	= TallyWordPressPlugin::GetTallyClientURL();
	$data['cid'] 	= $cid;
	$data['isnoc'] 	= $isnoc;
	foreach ($options['getData'] as $k=>$v) {$data[$k] = $v;}
	$queryString 	= http_build_query($data);

	$url = TallyWordPressPlugin::$ANALYTICS_SERVER . '/' . TallyWordPressPlugin::$VERSION_PATH . '/' . $dataPath . '?' . $queryString;

	$request = new WP_Http;
	$result = $request->request($url,array('method'=>'POST','body'=>$options['postData'],'timeout'=>60));

	if(is_wp_error($result)){
		$str = "<pre>Error retrieving dash.<\n>" . print_r($result,true) . "\n" . $url . "\n</pre>";
		echo $str;
		return false;
	}

	//	If we're here, no error
	$jsInsert = "<script type='text/javascript'>TALLY_BLOG_URL='http://{$data['site']}'</script>";
	$response = $jsInsert . $result['body'];
	if(true == $options['echo']){echo $response;return;}
	else {return $response;}

}


function TallySiteSummary($atts) {
	$dataPath = '/WidgetAPI/Dash_SiteSummary.php';
	TallyDashUtility($atts,$dataPath);
}

function TallyUptime($atts) {
	//	Site and CID
	$dataPath = '/WidgetAPI/Dash_Uptime.php';
	TallyDashUtility($atts,$dataPath);
}

function TallyDashGoals($atts) {
	$dataPath = '/WidgetAPI/Dash_Goals.php';
	$tab = TallyDashUtility($atts,$dataPath,array('echo'=>false));
	GoalTracking::RenderGoalsConfigurePage($tab);
}

function TallyDashSetup($atts) {
	//	The setup page is a local page
	include(dirname(__FILE__) . '/includes/SetupScreen.php');
	return;
}

function TallyDashOverview($atts) {
	$dataPath = '/WidgetAPI/Dash_Overview.php';
	TallyDashUtility($atts,$dataPath);
}

function TallyDashSearchPages($atts) {
	$dataPath = '/WidgetAPI/Dash_SearchPages.php';
	TallyDashUtility($atts,$dataPath);
}

function TallyDashSearchReaders($atts) {
	$dataPath = '/WidgetAPI/Dash_SearchReaders.php';
	TallyDashUtility($atts,$dataPath);
}

function TallyDashDiagnostics($atts) {
	$dataPath = '/WidgetAPI/Dash_PluginSetup.php';
	TallyDashUtility($atts,$dataPath);
}

function TallyDashLive($atts) {
	$dataPath = '/WidgetAPI/Dash_Live.php';
	TallyDashUtility($atts,$dataPath);
}

function TallyDashLast24($atts) {
	$dataPath = '/WidgetAPI/Dash_Last24.php';
	TallyDashUtility($atts,$dataPath);
}

function TallyDashLast90($atts) {
	$dataPath = '/WidgetAPI/Dash_Last90.php';
	TallyDashUtility($atts,$dataPath);
}

function TallyopiaAdminBarMenu(&$wp_admin_bar) {
	//	Only for top level admins
	if (!TallyWordPressPlugin::IsTopLevelAdmin()) {return;}

	//	If you're looking at a tallyopia page, don't show it.
	//if (false !== stripos($_GET['page'],'tally')) {return;}

	//	If you're looking at an admin page, don't show it
	//if (is_admin()) {return;}


	//	TODO - allow admin to select what to see in admin bar.
	//	Requires tweaks to visibility of Setup menu
	//	Add the link to the Tallyopia dash
	//	Use strings "show" and "hide"
	/*
	$showTallyopia 	= get_the_author_meta('tallyopia_admin_showtally',$currentUserID);
	$showGoals		= get_the_author_meta('tallyopia_admin_showgoals',$currentUserID);
	$showLive		= get_the_author_meta('tallyopia_admin_showlive',$currentUserID);
	$showRecent		= get_the_author_meta('tallyopia_admin_showrecent',$currentUserID);
	*/
	//	END TODO

	$currentUser 	= wp_get_current_user();
	$currentUserID	= $currentUser->ID;

	//	If we don't want to show it, then don't show it
	$showBar = get_the_author_meta('tallyopia_show_admin_bar',$currentUserID);
	if ('false' == $showBar) {return;}


	$tallopiaIcon = TallyWordPressPlugin::GetTallyopiaIconURL();
	$url = add_query_arg('page','tally-root',admin_url('admin.php'));
	$tallyT = plugin_dir_url(__FILE__) . '/assets/TallyT.png';
	$menu = array('id'=>'TallyopiaAdminBar-ToDash'
					,'title'=>"<img src='{$tallyT}'>"
					,'href'=>$url
					,'meta'=>array('html'=>"",'class'=>'','title'=>'Tallyopia'));
	$wp_admin_bar->add_menu($menu);

	//	Define data path
	$dataPath = '/WidgetAPI/Dash_AdminBar.php';

	//	Add the goals reached
	$goalHtml = wp_cache_get('admingoalsreached','tallyopia');
	if (false == $goalHtml) {
		$goalHtml = TallyDashUtility(array(),$dataPath,array('echo'=>false,'postData'=>array('action'=>'goals')));
		wp_cache_set('admingoalsreached',$goalHtml,'tallyopia',300);
	}
	if (false !== $goalHtml) {
		$menu = array(	'id'		=> 'TallyopiaAdminBar-GoalsReached'
						,'title'	=> "<span id='tallyopiaAdminBarGoalsSpan' style='color:#73AB00'></span>"
						,'href'		=> add_query_arg('page','tally-goals',admin_url('admin.php'))
						,'meta'		=> array('html'=>$goalHtml)
						);
		$wp_admin_bar->add_menu($menu);
	}

	//	Add the count of live users
	$liveHtml = wp_cache_get('adminliveusers','tallyopia');
	if (false === $liveHtml) {
		$liveHtml = TallyDashUtility(array(),$dataPath,array('echo'=>false,'getData'=>array('action'=>'live')));
		wp_cache_set('adminliveusers',$liveHtml,'tallyopia',10);
	}
	if (false !== $liveHtml) {
		$menu = array(	'id' 		=> 'TallyopiaAdminBar-LiveUsers'
						,'title' 	=> "<span id='tallyopiaAdminBarLiveViewersSpan' style='color:#F6CE07'></span>"
						,'href'		=> add_query_arg('page','tally-live',admin_url('admin.php'))
						,'meta' 	=> array('html'=>$liveHtml)
						);
		$wp_admin_bar->add_menu($menu);
	}

	//	Add the chart
	$chartHtml = wp_cache_get('adminbarchart','tallyopia');
	if (false === $chartHtml) {
		$chartHtml = TallyDashUtility(array(),$dataPath,array('echo'=>false,'getData'=>array('action'=>'recent')));
		wp_cache_set('adminbarchart',$chartHtml,'tallyopia',60);
	}
	if (false !== $chartHtml) {
		//	Add the chart
		$menu = array(	'id'		=> 'TallyopiaAdminBar-Chart'
						,'title'	=> "<span id='tallyopiaAdminBarChartSpan' ></span>"
						,'meta' 	=> array('html'=>$chartHtml)
					);
		$wp_admin_bar->add_menu($menu);
	}


}

function TallyShortcodeFcn_Last24($atts) {
	$atts = shortcode_atts( array(
				'widget' => null
				,'width' => 270
				,'height' => 300
				,'float' =>''
				,'showtable' => 1
				,'showview' => 1
				,'showdetail' => 0 // Override this below
				,'back' => null
				,'items' => ''
				), $atts );

	if (null == $atts['widget']) {return '';}

	//	Override defaults for eventmap and searchmap
	if ( stristr($atts['widget'],'eventmap') || stristr($atts['widget'],'searchmap') ) {
		$atts['showdetail'] = 1;
	}

	$data = array();
	$url = get_bloginfo('wpurl');
	$data['site'] = substr($url,strrpos($url,'/')+1);
	$data['widget'] = $atts['widget'];
	$data['height'] = $atts['height'];
	$data['width'] = $atts['width'];
	$data['float'] = $atts['float'];
	$data['showtable'] = $atts['showtable'];
	$data['showview'] = $atts['showview'];
	$data['showdetail'] = $atts['showdetail'];
	$data['back'] = $atts['back'];
	$data['items'] = $atts['items'];
	$data['isadmin'] = current_user_can('administrator') ? 1 : 0;

	global $TALLY_CALLED;
	$data['tally_called'] = $TALLY_CALLED;
	$TALLY_CALLED = true;

	$queryString = http_build_query($data);

	if (false !== stristr($atts['widget'],'last24_')) {
		global $TALLY_CALLED_LAST24;
		$queryString .= '$TALLY_CALLED_LAST24=' . $TALLY_CALLED_LAST24;
		$q = TallyWordPressPlugin::$ANALYTICS_SERVER . '/' . TallyWordPressPlugin::$VERSION_PATH . '/' . '/WidgetAPI/Widget_Last24.php?' . $queryString;
		$TALLY_CALLED_LAST24 = true;
	}

	if (false != stristr($atts['widget'],'live_')) {
		global $TALLY_CALLED_LIVE;
		$queryString .= '&TALLY_CALLED_LIVE=' . $TALLY_CALLED_LIVE;
		$q = TallyWordPressPlugin::$ANALYTICS_SERVER . '/' . TallyWordPressPlugin::$VERSION_PATH . '/' . '/WidgetAPI/Widget_Live.php?' . $queryString;
		$TALLY_CALLED_LIVE = true;
	}

	$request = new WP_Http;
	$result = $request->request($q);

	$jsInsert = "<script type='text/javascript'>TALLY_BLOG_URL='{$url}'</script>";

	if(!is_wp_error($result)){return $jsInsert . $result['body'];}
	else {
		$str = "<pre><!--\nTallyopia Error\n" . print_r($result,true) . "\n" . $q . "\n--></pre>";
		return $str;
	}

}

class TallyWordPressPlugin {
	public static $DEBUG = false;
	public static $METHOD = 'JQUERY';//SERVER_POST';
	public static $SERVER = 'http://www.tallyopia.net';//  This is replaced at initialization.
	public static $ANALYTICS_SERVER = 'http://analytics.tallyopia.net';
	public static $VERSION_PATH = '/v1.3/';
	public static $EVENT_JS = '/Event.js';
	public static $LOG_EVENT_SCRIPT = 'LogEvent.php';
	public static $LOG_PING_SCRIPT = 'LogPing.php';
	public static $SHORTCODE_TAG = 'tallyopia';

	public static function GetTallyopiaIconURL() {
		$tallyopiaIconURL =  plugin_dir_url( __FILE__ ) . '/assets/favicon_bw.png';
		return $tallyopiaIconURL;
	}

	public static function AddAdminBarMenu() {
		//	Only show for top level admin
		add_action('admin_bar_menu','TallyopiaAdminBarMenu',99999);
	}

	public static function AddGoalTrackingBoxes() {
		include( dirname(__FILE__) . '/includes/GoalTracking.php');
		add_action('add_meta_boxes',array('GoalTracking','AddGoalBoxes'));
		add_action('save_post',array('GoalTracking','SaveGoalBox'));
	}

	public static function EnableShortcodesInWidgets() {
		if (!is_admin()) {add_filter('widget_text', 'do_shortcode', 11);}
	}

	public static function AddDashboardMenu() {
		add_action('admin_menu', 'TallyInDash');
		add_action('network_admin_menu','TallyInDash');
	}

	public static function AddShortcode() {
		add_shortcode(TallyWordPressPlugin::$SHORTCODE_TAG, 'TallyShortcodeFcn_Last24');
	}

	public static function HookActionToFooter() {
		add_action('wp_footer', 'TallyWordPressPlugin::DoAction', 9999);
	}

	public static function InitJQuery() {
		add_action('init','TallyWordPressPlugin::LoadJQuery');
	}
	public static function LoadJQuery() {
		if (!is_admin()) {
			wp_deregister_script('jquery');
			wp_register_script('jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.6.1/jquery.min.js', false, '1.6.1', false);
			wp_enqueue_script('jquery');
		}
	}

	public static function DoAction($content) {
		echo "<!-- Tallyopia Plugin ... tallyhere -->";
		$DEBUG = TallyWordPressPlugin::$DEBUG;
		$METHOD = TallyWordPressPlugin::$METHOD;

		//	Don't run if user is an admin
		if (current_user_can('administrator')) {return $content;}

		//	Don't run on admin pages.
		if (is_admin()) {return $content;}

		//	Don't run on private pages
		if (TallyWordPressPlugin::GetIsPrivate()) {return $content;}

		//	STATIC, so we can't reference $this
		$pageType = 'unknown';
		$entry = 'unknown';
		$dataCount = 1;
		$dontLog = False;

		$TITLE	 	= array();
		$CATEGORIES = array();
		$TAGS 		= array();
		$EVENT		= array();
		$RESULTS	= array();
		$AUTHOR		= TallyWordPressPlugin::GetBlogName('None');

		// print('<!-- calldoaction -->');

		if (true == is_front_page()) {
			$EVENT 		= array('home');
			$entry 		= 'home';
			$CATEGORIES =  array('Home');
			$TITLE		= TallyWordPressPlugin::GetBlogName('Home');
		}

		if (true == is_home()) {
			$EVENT 		=  array('home');
			$CATEGORIES =  array('Home');
			$TITLE		=  TallyWordPressPlugin::GetBlogName('Home');
			$entry 		=  'home';
		}

		if (true == is_single()) {
			$EVENT 		= array('single');
			$TITLE 		= TallyWordPressPlugin::GetSinglePageTitle();
			$CATEGORIES = TallyWordPressPlugin::GetCategories();
			$TAGS		= TallyWordPressPlugin::GetTags();
			$AUTHOR 	= array(TallyWordPressPlugin::GetAuthor());
		}

		if (true == is_tag()) {
			$EVENT 		= array('tag');
			$TITLE		= TallyWordPressPlugin::GetSingleTag();
			$RESULTS	= TallyWordPressPlugin::GetCount();
			$CATEGORIES = $TITLE;
		}

		if (true == is_category()) {
			$EVENT 		= array('category');
			$TITLE 		= TallyWordPressPlugin::GetSingleCategory();
			$RESULTS	= TallyWordPressPlugin::GetCount();
			$CATEGORIES = $TITLE;
		}

		if (true == is_author()) {
			$EVENT 		= array('author');
			$TITLE 		= TallyWordPressPlugin::GetSinglePageTitle();
			$RESULTS	= TallyWordPressPlugin::GetCount();
			$AUTHOR		= $TITLE;
		}


		if (true == is_date()) {
			$EVENT 		= array('date');
			$TITLE 		= TallyWordPressPlugin::GetSingleDate();
			$RESULTS	= TallyWordPressPlugin::GetCount();
		}

		if (true == is_search()) {
			$EVENT 		= array('search');
			$TITLE 		= get_search_query();
			$RESULTS	= TallyWordPressPlugin::GetCount();
		}

		if (true == is_page()) {
			$EVENT 		= array('page');
			$TITLE		= TallyWordPressPlugin::GetSinglePageTitle();
			$AUTHOR 	= array(TallyWordPressPlugin::GetAuthor());
			$CATEGORIES = TallyWordPressPlugin::GetPageParent();
		}

		if (true == is_404()) {
			global $wp_query;
			$EVENT	= array('404 Error');
			$TITLE	= array($wp_query->query['pagename']);
		}

		if (true == is_paged()) {$dontLog = true;}

		//	Exit now if we aren't supposed to log.
		if (true == $dontLog) {return $content;}

		//	Add fields for all the types
		$IP 		= $METHOD == 'SERVER_POST' ? array(TallyWordPressPlugin::GetIP()) : array('auto');
		$TIMESTAMP 	= $METHOD == 'SERVER_POST' ? array(date('Y-m-d H:i:s')) : array('auto');;
		$WEBSITE	= TallyWordPressPlugin::GetTallyClientURL();
		$LINK		= array(esc_url($_SERVER['REQUEST_URI']));
		$WEBSITEKEY = array('websitekeyvalue');
		$USER_EMAIL = array(TallyWordPressPlugin::GetUserEmail());
		$METHOD_ARR	= array($METHOD);

		//	Set is_goal for single page entries only
		$IS_GOAL	= array(TallyWordPressPlugin::GetIsGoal());
		if (	is_404() || is_search() || is_date()
			|| 	is_author() || is_category() || is_tag()
			) {	$IS_GOAL = 0;}

		$fieldsToSend = array($EVENT, $TITLE, $CATEGORIES, $TAGS, $RESULTS, $IP, $TIMESTAMP, $WEBSITE, $WEBSITEKEY, $AUTHOR, $LINK, $IS_GOAL);
		$fieldNames   = array('EVENT','TITLE','CATEGORIES','TAGS','RESULTS','IP','TIMESTAMP','WEBSITE','WEBSITEKEY','AUTHOR','LINK','IS_GOAL');
		$dataHash = array_combine($fieldNames,$fieldsToSend);

		//	Do some debug printing
		if (true == $DEBUG) {
			echo "<!-- \n\n";
			echo "Plugin Debug Info", "\n", "Method: $METHOD","\n";
			print_r($dataHash);
			echo "\n\n -->";
		}
		//	Serialize it in JSON form, base64 encode, and package.
		$payload['payload'] = base64_encode(json_encode($dataHash));

		//	Send the data.
		switch ($METHOD) {
			case 'JQUERY':
				$response = TallyWordPressPlugin::DoJquery(TallyWordPressPlugin::$SERVER,'POST',$payload);
				break;
		}
		if (true == $DEBUG) {
			echo "\n\n<!--\n\n";
			print_r($response);
			echo "\n\n-->";
		}

		return $content;
	}

	private static function GetBlogName($default='Home') {
		$name = get_bloginfo('name');
		if (strlen($name)<1) {$name = $default;}
		return $name;
	}

	private static function GetIsGoal() {
		global $post;
		$isGoal = GoalTracking::IsGoal($post->ID);
		$returnValue = $isGoal ? 1:0;
		return $returnValue;
	}

	private static function GetPageParent() {
		global $wp_query;
		$id = $wp_query->post->post_parent;
		$title = get_the_title($id);
		return array($title);
	}

	private static function GetIsPrivate() {
		global $post;
		$privacy = ($post->post_status == 'private');
		return $privacy;
	}

	private static function GetCount() {
		global $wp_query;
		return array($wp_query->found_posts);
	}

	private static function GetAuthor() {
		global $post;
		$postID = $post->post_author;
		$data = get_userdata(intval($postID));
		return $data->display_name;
	}

	private static function GetUserEmail() {
		$email = NULL;
		$user = wp_get_current_user();
		if (is_user_logged_in()) {
			$email = array($user->user_email);
			$name = array($user->display_name);
		}
		return $email;
	}

	private static function GetSinglePageTitle() {
		$t = NULL;
		if (is_home () ) {$t = bloginfo('name');}
		elseif (is_category()) 	{$t = single_cat_title('',false);}
		elseif (is_single()) 	{$t = single_post_title('',false);}
		elseif (is_page()) 		{$t = single_post_title('',false);}
		elseif (is_author())	{$t = strip_tags(wp_title('',false));}
		else {$t = wp_title('',false); }

		if (NULL == $t) {return array('(Untitled)');}
		return array($t);
	}


	private static function GetSingleCategory() {
		global $wp;
		return array($wp->query_vars['category_name']);
	}

	private static function GetCategories() {
		$allCategories = array();
		$cats = get_the_category();
		if (false == $cats) {return $allCategories;}
		foreach($cats as $category) {
    		array_push($allCategories, $category->cat_name);
		}
		return $allCategories;
	}


	private static function GetSingleTag() {
		global $wp;
		return array($wp->query_vars['tag']);
	}
	private static function GetTags() {
		$maxTagCount = 10;
		$allTags = array();
		$tags = get_the_tags();
		if (false == $tags) {return $allTags;}
		while (count($tags)>0 && count($allTags)<$maxTagCount) {
			$item = array_pop($tags);
			array_push($allTags,$item->name);
		}
		return $allTags;
	}

	private static function GetDates() {
		return GetSingleDate();
	}
	private static function GetSingleDate() {
		$d = get_the_date('Y-m-d');
		return array($d);
	}

	private static function GetIP() {
		$ip = NULL;
		if (getenv("HTTP_CLIENT_IP")) {$ip = getenv("HTTP_CLIENT_IP");}
		else if(getenv("HTTP_X_FORWARDED_FOR")) {$ip = getenv("HTTP_X_FORWARDED_FOR");}
		else if(getenv("REMOTE_ADDR")) {$ip = getenv("REMOTE_ADDR");}
		else {
			//$ip = "UNKNOWN";
		}
		return $ip;
	}

	public static function GetTallyClientURL(){
		$WEBSITE 	= get_bloginfo('wpurl');
		$WEBSITE	= str_replace('https://','',$WEBSITE);
		$WEBSITE	= str_replace('http://' ,'',$WEBSITE);
		if (preg_match("/^www./",$WEBSITE)) {$WEBSITE=substr($WEBSITE,4);}
		$websiteParts = explode("/",$WEBSITE);
		$WEBSITE	= $websiteParts[0];
		return $WEBSITE;
	}

	public static function IsTopLevelAdmin() {
		//	Used to know when to show admin only tools.
		return (
					( is_multisite() && is_super_admin() )
					||
					(!is_multisite() && current_user_can('administrator'))
				);
	}
	private static function DoJquery($host,$method,$data=NULL) {
		if (is_array($data)) {
	        $dataElements = array();
	        $dataKeys = array_keys($data);
	 		foreach ($dataKeys as $k) {
	        	array_push($dataElements,urlencode($k) ."=". urlencode($data[$k]));
	        }
	 		$data = implode("&",$dataElements);
		}

		$scriptSrc = (TallyWordPressPlugin::$SERVER . '/' . TallyWordPressPlugin::$VERSION_PATH . '/' . TallyWordPressPlugin::$EVENT_JS);

		echo '<script type="text/javascript">';
		echo 'jQuery.noConflict();';
		echo "_trackerObj = new Object();";
		echo "_trackerObj['log_url'] = '" . TallyWordPressPlugin::$SERVER . '/' . TallyWordPressPlugin::$VERSION_PATH . '/' . TallyWordPressPlugin::$LOG_EVENT_SCRIPT ."';";
		echo "_trackerObj['ping_url'] = '" .TallyWordPressPlugin::$SERVER . '/' . TallyWordPressPlugin::$VERSION_PATH . '/' . TallyWordPressPlugin::$LOG_PING_SCRIPT  ."';";
		echo "var payloadData = '" . $data ."';";

		echo " (function() { ";
		echo " var g = document.createElement('script'); g.type = 'text/javascript'; g.async = true;";
		//echo " g.src = ('https:' == document.location.protocol ? 'https://' : 'http://') + '{$scriptSrc}';";
		echo " g.src = '{$scriptSrc}';";
		echo " var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(g, s);";
		echo " })();";
		echo '</script>',"\r\n";
		return '';
	}

}

#	---------------------------
